;;;;
;;;; conditional -- Provide when and unless macros.
;;;;
;;;; Copyright 2005 Dean Ferreyra, All rights reserved
;;;;
;;;; This file is part of octw-guile-general.
;;;;
;;;; octw-guile-general is free software: you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation, either version 3 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; octw-guile-general is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with octw-guile-general.  If not, see
;;;; <http://www.gnu.org/licenses/>.
;;;;
;;;; $Id: conditional.scm,v 1.1 2008-09-04 03:40:47 dean Exp $

(define-module (octw conditional))

(export when
        unless)

(use-syntax (ice-9 syncase))

(define-syntax when
  (lambda (form)
    (syntax-case form ()
      ((_ test body ...)
       (syntax (if test
                   (begin body ...)))))))

(define-syntax unless
  (lambda (form)
    (syntax-case form ()
      ((_ test body ...)
       (syntax (if (not test)
                   (begin body ...)))))))
